=== fluidsynth/src/main/jni/fluidsynth-android/CMakeLists.txt ===
# FluidSynth - A Software Synthesizer
#
# Copyright (C) 2003-2025 Peter Hanappe and others.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307, USA

# CMake based build system. Pedro Lopez-Cabanillas <plcl@users.sf.net>

if ( ANDROID_ABI )

cmake_minimum_required ( VERSION 3.13 )
# 3.1 because of CMAKE_C_STANDARD
# 3.11 because COMPATIBILITY SameMinorVersion in CMakePackageConfigHelpers
# 3.13.5 because it is the latest supported in Windows XP

if(POLICY CMP0075) # CMake version 3.13.5 warns when the policy is not set or value is OLD
  cmake_policy(SET CMP0075 NEW)
endif()

if(POLICY CMP0091) # new in CMake 3.15, defaults to OLD
  cmake_policy(SET CMP0091 NEW)
endif()

if(POLICY CMP0099) # new in CMake 3.17, defaults to OLD
  cmake_policy(SET CMP0099 NEW)
elseif(NOT BUILD_SHARED_LIBS)
  message(WARNING "Your version of CMake is very old. This may cause linking issues if your dependencies are not in your compiler's default search paths.")
endif()

project ( FluidSynth C CXX )

# FluidSynth package name
set ( PACKAGE "fluidsynth" )

# FluidSynth package version
set ( FLUIDSYNTH_VERSION_MAJOR 2 )
set ( FLUIDSYNTH_VERSION_MINOR 4 )
set ( FLUIDSYNTH_VERSION_MICRO 6 )
set ( VERSION "${FLUIDSYNTH_VERSION_MAJOR}.${FLUIDSYNTH_VERSION_MINOR}.${FLUIDSYNTH_VERSION_MICRO}" )
set ( FLUIDSYNTH_VERSION ${VERSION} )

# libfluidsynth - Library version
# *** NOTICE ***
# Update library version upon each release (follow these steps in order)
# if any source code changes: REVISION++
# if any interfaces added/removed/changed: REVISION=0
# if any interfaces removed/changed (compatibility broken): CURRENT++
# if any interfaces have been added: AGE++
# if any interfaces have been removed/changed (compatibility broken): AGE=0
# This is not exactly the same algorithm as the libtool one, but the results are the same.
set ( LIB_VERSION_CURRENT 3 )
set ( LIB_VERSION_AGE 2 )
set ( LIB_VERSION_REVISION 1 )
set ( LIB_VERSION_INFO
      "${LIB_VERSION_CURRENT}.${LIB_VERSION_AGE}.${LIB_VERSION_REVISION}" )

# the default C standard to use for all targets
set(CMAKE_C_STANDARD 90)

# the default C++ standard to use for all targets
set(CMAKE_CXX_STANDARD 98)

# whether to use gnu extensions
set(CMAKE_C_EXTENSIONS ON)
set(CMAKE_CXX_EXTENSIONS OFF)

include_directories (
    android
    ${CMAKE_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_SOURCE_DIR}/src/drivers
    ${CMAKE_SOURCE_DIR}/src/synth
    ${CMAKE_SOURCE_DIR}/src/rvoice
    ${CMAKE_SOURCE_DIR}/src/midi
    ${CMAKE_SOURCE_DIR}/src/utils
    ${CMAKE_SOURCE_DIR}/src/sfloader
    ${CMAKE_SOURCE_DIR}/src/bindings
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}/include
)

set ( config_SOURCES android/config.h )

set ( libfluidsynth_SOURCES
    src/utils/fluid_conv.c
    src/utils/fluid_conv.h
    src/utils/fluid_hash.c
    src/utils/fluid_hash.h
    src/utils/fluid_list.c
    src/utils/fluid_list.h
    src/utils/fluid_ringbuffer.c
    src/utils/fluid_ringbuffer.h
    src/utils/fluid_settings.c
    src/utils/fluid_settings.h
    src/utils/fluidsynth_priv.h
    src/utils/fluid_sys.c
    src/utils/fluid_sys.h
    src/sfloader/fluid_defsfont.c
    src/sfloader/fluid_defsfont.h
    src/sfloader/fluid_sfont.c
    src/sfloader/fluid_sfont.h
    src/sfloader/fluid_sffile.c
    src/sfloader/fluid_sffile.h
    src/sfloader/fluid_samplecache.c
    src/sfloader/fluid_samplecache.h
    src/rvoice/fluid_adsr_env.c
    src/rvoice/fluid_adsr_env.h
    src/rvoice/fluid_chorus.c
    src/rvoice/fluid_chorus.h
    src/rvoice/fluid_iir_filter_impl.cpp
    src/rvoice/fluid_iir_filter.c
    src/rvoice/fluid_iir_filter.h
    src/rvoice/fluid_lfo.c
    src/rvoice/fluid_lfo.h
    src/rvoice/fluid_rvoice.c
    src/rvoice/fluid_rvoice.h
    src/rvoice/fluid_rvoice_dsp.cpp
    src/rvoice/fluid_rvoice_event.c
    src/rvoice/fluid_rvoice_event.h
    src/rvoice/fluid_rvoice_mixer.c
    src/rvoice/fluid_rvoice_mixer.h
    src/rvoice/fluid_phase.h
    src/rvoice/fluid_rev.c
    src/rvoice/fluid_rev.h
    src/synth/fluid_chan.c
    src/synth/fluid_chan.h
    src/synth/fluid_event.c
    src/synth/fluid_event.h
    src/synth/fluid_gen.c
    src/synth/fluid_gen.h
    src/synth/fluid_mod.c
    src/synth/fluid_mod.h
    src/synth/fluid_synth.c
    src/synth/fluid_synth.h
    src/synth/fluid_synth_monopoly.c
    src/synth/fluid_tuning.c
    src/synth/fluid_tuning.h
    src/synth/fluid_voice.c
    src/synth/fluid_voice.h
    src/midi/fluid_midi.c
    src/midi/fluid_midi.h
    src/midi/fluid_midi_router.c
    src/midi/fluid_midi_router.h
    src/midi/fluid_seqbind.c
    src/midi/fluid_seq.c
    src/midi/fluid_seq_queue.cpp
    src/midi/fluid_seq_queue.h
    src/midi/fluid_seqbind_notes.cpp
    src/midi/fluid_seqbind_notes.h
    src/drivers/fluid_adriver.c
    src/drivers/fluid_adriver.h
    src/drivers/fluid_mdriver.c
    src/drivers/fluid_mdriver.h
    src/bindings/fluid_filerenderer.c
    android/src/bindings/fluid_cmd.c
    src/bindings/fluid_cmd.h
    src/drivers/fluid_opensles.c
)

set ( public_HEADERS
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/audio.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/event.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/gen.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/ladspa.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/log.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/midi.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/misc.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/mod.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/seq.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/seqbind.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/settings.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/sfont.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/shell.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/synth.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/types.h
    ${CMAKE_SOURCE_DIR}/include/fluidsynth/voice.h
    ${CMAKE_BINARY_DIR}/include/fluidsynth/version.h
)

set ( public_main_HEADER
    ${CMAKE_BINARY_DIR}/include/fluidsynth.h
)

configure_file ( ${CMAKE_SOURCE_DIR}/include/fluidsynth/version.h.in 
                 ${CMAKE_BINARY_DIR}/include/fluidsynth/version.h )
configure_file ( ${CMAKE_SOURCE_DIR}/include/fluidsynth.cmake
                 ${public_main_HEADER} )

add_library ( libfluidsynth-OBJ OBJECT
    ${config_SOURCES}
    ${libfluidsynth_SOURCES}
    ${public_HEADERS}
    ${public_main_HEADER}
)

target_compile_definitions(libfluidsynth-OBJ PRIVATE OPENSLES_SUPPORT)

if(ANDROID_ABI STREQUAL "armeabi-v7a")
        target_compile_options(libfluidsynth-OBJ PRIVATE -DWITH_FLOAT)
endif()
if(ANDROID_ABI STREQUAL "x86")
        target_compile_options(libfluidsynth-OBJ PRIVATE -DWITH_FLOAT)
endif()

target_compile_options(libfluidsynth-OBJ
                            PRIVATE
                            -Wall
                            -DHAVE_CONFIG_H
                            -Wno-unused-variable
                            -Wno-error=format
                            "$<$<CONFIG:DEBUG>:-Werror>" # Only include -Werror when building debug config
)

add_library ( libfluidsynth $<TARGET_OBJECTS:libfluidsynth-OBJ> )

find_library(OPENSL_LIB OpenSLES)

target_link_libraries(libfluidsynth PRIVATE ${OPENSL_LIB})

set_target_properties ( libfluidsynth
    PROPERTIES
      PUBLIC_HEADER "${public_HEADERS}"
      PREFIX "lib"
      OUTPUT_NAME "fluidsynth"
      VERSION ${LIB_VERSION_INFO}
      SOVERSION ${LIB_VERSION_CURRENT}
)

install ( TARGETS libfluidsynth
    LIBRARY DESTINATION lib/${ANDROID_ABI}
    ARCHIVE DESTINATION lib/${ANDROID_ABI}
    PUBLIC_HEADER DESTINATION include/fluidsynth
)
install ( FILES ${public_main_HEADER} DESTINATION include )

# ******* Auto Generated Lookup Tables ******

if (NOT ANDROID)
include(ExternalProject)
ExternalProject_Add(gentables
        DOWNLOAD_COMMAND ""
        SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/gentables
        BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/src/gentables
        INSTALL_COMMAND ${CMAKE_CURRENT_BINARY_DIR}/src/gentables/make_tables.exe "${CMAKE_BINARY_DIR}/"
        CMAKE_GENERATOR "Unix Makefiles"
)
add_dependencies(libfluidsynth-OBJ gentables)
endif ()
else ( ANDROID_ABI )

cmake_minimum_required ( VERSION 3.13 )
# 3.1 because of CMAKE_C_STANDARD
# 3.11 because COMPATIBILITY SameMinorVersion in CMakePackageConfigHelpers
# 3.13.5 because it is the latest supported in Windows XP

if(POLICY CMP0075) # CMake version 3.13.5 warns when the policy is not set or value is OLD
  cmake_policy(SET CMP0075 NEW)
endif()

if(POLICY CMP0091) # new in CMake 3.15, defaults to OLD
  cmake_policy(SET CMP0091 NEW)
endif()

if(POLICY CMP0099) # new in CMake 3.17, defaults to OLD
  cmake_policy(SET CMP0099 NEW)
elseif(NOT BUILD_SHARED_LIBS)
  message(WARNING "Your version of CMake is very old. This may cause linking issues if your dependencies are not in your compiler's default search paths.")
endif()

project ( FluidSynth C CXX )
list( APPEND CMAKE_MODULE_PATH ${FluidSynth_SOURCE_DIR}/cmake_admin )

# FluidSynth package name
set ( PACKAGE "fluidsynth" )

# FluidSynth package version
set ( FLUIDSYNTH_VERSION_MAJOR 2 )
set ( FLUIDSYNTH_VERSION_MINOR 4 )
set ( FLUIDSYNTH_VERSION_MICRO 6 )
set ( VERSION "${FLUIDSYNTH_VERSION_MAJOR}.${FLUIDSYNTH_VERSION_MINOR}.${FLUIDSYNTH_VERSION_MICRO}" )
set ( FLUIDSYNTH_VERSION ${VERSION} )

# libfluidsynth - Library version
# *** NOTICE ***
# Update library version upon each release (follow these steps in order)
# if any source code changes: REVISION++
# if any interfaces added/removed/changed: REVISION=0
# if any interfaces removed/changed (compatibility broken): CURRENT++
# if any interfaces have been added: AGE++
# if any interfaces have been removed/changed (compatibility broken): AGE=0
# This is not exactly the same algorithm as the libtool one, but the results are the same.
set ( LIB_VERSION_CURRENT 3 )
set ( LIB_VERSION_AGE 3 )
set ( LIB_VERSION_REVISION 6 )
set ( LIB_VERSION_INFO
      "${LIB_VERSION_CURRENT}.${LIB_VERSION_AGE}.${LIB_VERSION_REVISION}" )

# Options disabled by default
option ( enable-coverage "enable gcov code coverage" off )
option ( enable-floats "enable type float instead of double for DSP samples" off )
option ( enable-fpe-check "enable Floating Point Exception checks and debug messages" off )
option ( enable-portaudio "compile PortAudio support" off )
option ( enable-profiling "profile the dsp code" off )
option ( enable-trap-on-fpe "enable SIGFPE trap on Floating Point Exceptions" off )
option ( enable-ubsan "compile and link against UBSan (for debugging fluidsynth internals)" off )

# Options enabled by default
option ( enable-alsa "compile ALSA support (if it is available)" on )
option ( enable-aufile "compile support for sound file output" on )
option ( BUILD_SHARED_LIBS "Build a shared object or DLL" on )
option ( enable-dbus "compile DBUS support (if it is available)" on )
option ( enable-ipv6  "enable IPv6 support at the cost of disabling IPv4" on )
option ( enable-jack "compile JACK support (if it is available)" on )
option ( enable-ladspa "enable LADSPA effect units" on )
option ( enable-libinstpatch "use libinstpatch (if available) to load DLS and GIG files" on )
option ( enable-libsndfile "compile libsndfile support (if it is available)" on )
option ( enable-midishare "compile MidiShare support (if it is available)" on )
option ( enable-opensles "compile OpenSLES support (if it is available)" off )
