=== CTranslate2/src/main/jni/CTranslate2/docs/requirements.txt ===
myst-parser==0.18.*
sphinx-rtd-theme==1.0.*
sphinx==5.3.*
