=== NG-GL4ES/src/main/jni/NG-GL4ES/debian/rules ===
#!/usr/bin/make -f


%:
	dh $@

override_dh_auto_test:
	# Disable auto tests at build time
	:

override_dh_auto_clean:
	dh_auto_clean
	rm -f lib/*.so*
